//Robo Cup  Commentater  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//LOGreplay뤿Υ饹
//
class BufferedReplay extends CReplay{

	int currentTime = 1;

	int startTime;
	int endTime;

	public BufferedReplay(MainWindow mw, String fname){

		super(mw, fname);
	
	}
	
	public void open(){

		DataInputStream dist;
		
		try{

		    if (fname.endsWith(".gz")){
                    
			//GZIPfile ؤΥȥ꡼
			dist = new DataInputStream(
                           new java.util.zip.GZIPInputStream
                               (new FileInputStream(fname)));
    
		    }else if (fname.endsWith(".zip")){

                    //ZIP file ؤΥȥ꡼
			dist = new DataInputStream(
                           new java.util.zip.ZipInputStream
                               (new FileInputStream(fname)));

		    }else{

                    //ɸΥȥ꡼κ
			dist = new DataInputStream(new FileInputStream(fname));

		    }
		
			//إåɤ߹
			byte[] disByte3 = new byte[3];
			dist.readFully(disByte3);
			String head  = new String(disByte3);

			dist.close();

			//öLogFileɤ߹

			readlf = new ReadLogFile3(fname); 
			
		}
		catch(IOException e) {
			e.printStackTrace();
		}
	}

        public void fileEnding(){

	        super.fileEnding();

		/*
		ScoreBookWindow scoreBook = new ScoreBookWindow(mw, aInfo);

		scoreBook.init();

		scoreBook.show();
		*/
		
	}

    public void openScorebook(){

		ScoreBookWindow scoreBook = new ScoreBookWindow(mw, aInfo);

		scoreBook.init();

		scoreBook.show();

    }

	public int timeConvertStep(int time){

		int step = time - 1;

		System.out.println(time);

		ReadLogFile3 readlf3 = (ReadLogFile3)readlf;

		while(readlf3.getShowInfo(step).getTime() != time){		
			step++;

		}

		System.out.println(time);
		
		return step;

	}

	public void startAnalyze(int startTime, int endTime){ 
	
		this.startTime = startTime;		
		this.endTime   = endTime;

		aInfo = new AnalyzeInfo(fname);		

		aInfo.addObserver(mw);

			if (CParam.SCREEN_ON){
				aInfo.addObserver(mw.getCField());
	
				aInfo.addObserver(mw.getPlayerWin());	
			}

		start();

	}
	public void run(){

		currentTime = timeConvertStep(startTime);
				
		ReadLogFile3 readlf3 = (ReadLogFile3)readlf;
			
		while((sInfo = readlf3.getShowInfo(currentTime)) != null){
								
			currentTime++;

			if (sInfo.getTime() <= endTime){ 

				sInfo2rInfo();	
			
				aInfo.analyze();
		
				//ReplayInfo줿Ȥ롣
				
				aInfo.changes();

				try{
					sleep(30);
				}
				catch(InterruptedException e){}
			
				if (sInfo.getTime() == endTime){
					
					break;

				}
				
			}
			else{
				break;
			}
		}
		//ե뤬ä

		System.out.println("analyze end");

		fileEnding();			

	}
}
	
